unit mTBruchrechner;

interface

uses mSuM, mTBruch;

type TBruchrechner=class

  kenntBruch1, kenntBruch2, kenntErgebnisbruch : TBruch;

constructor init(pBruch1, pBruch2, Ergebnisbruch : TBruch);
procedure setzeBruch1(pBruch : TBruch);
procedure setzeBruch2(pBruch : TBruch);
function ergebnisbruch:TBruch;
procedure addiere;
procedure subtrahiere;
procedure multipliziere;
procedure dividiere;
procedure macheGleichnamig;
destructor gibFrei;
end;

implementation

constructor TBruchrechner.init(pBruch1, pBruch2, Ergebnisbruch : TBruch);
begin
  kenntBruch1:=pBruch1;
  kenntBruch2:=pBruch2;
  kenntErgebnisbruch := Ergebnisbruch;
end;

procedure TBruchrechner.setzeBruch1(pBruch : TBruch);
begin
  kenntBruch1:=pBruch;
end;

procedure TBruchrechner.setzeBruch2(pBruch : TBruch);
begin
  kenntBruch2:=pBruch;
end;

function TBruchrechner.ergebnisbruch:TBruch;
begin
  result:=kenntErgebnisbruch;
end;

procedure TBruchrechner.addiere;
begin
  kenntErgebnisbruch.setzeZaehler(kenntBruch1.zaehler*kenntBruch2.nenner
    + kenntBruch2.zaehler*kenntBruch1.nenner);
  kenntErgebnisbruch.setzeNenner(kenntBruch1.nenner*kenntBruch2.nenner);
  kenntErgebnisbruch.kuerzevoll;

end;

procedure TBruchrechner.subtrahiere;
begin
  kenntErgebnisbruch.setzeZaehler(kenntBruch1.zaehler*kenntBruch2.nenner
    - kenntBruch2.zaehler*kenntBruch1.nenner);
  kenntErgebnisbruch.setzeNenner(kenntBruch1.nenner*kenntBruch2.nenner);
  kenntErgebnisbruch.kuerzevoll;
end;

procedure TBruchrechner.multipliziere;
begin
  kenntErgebnisbruch.setzeZaehler(kenntBruch1.zaehler*kenntBruch2.zaehler);
  kenntErgebnisbruch.setzeNenner(kenntBruch1.nenner*kenntBruch2.nenner);
  kenntErgebnisbruch.kuerzevoll;
end;

procedure TBruchrechner.dividiere;
begin
  kenntBruch2.kehrbruch;
  self.multipliziere;
  kenntBruch2.kehrbruch;
end;

procedure TBruchrechner.macheGleichnamig;
  var lHauptnenner : GanzeZahl;
begin
  kenntBruch1.kuerzeVoll;
  kenntBruch2.kuerzeVoll;
  lHauptnenner:=kenntBruch1.nenner*kenntBruch2.nenner;
  kenntBruch1.erweitereUm(lHauptnenner div kenntBruch1.nenner);
  kenntBruch2.erweitereUm(lHauptnenner div kenntBruch2.nenner);
end;

destructor TBruchrechner.gibFrei;
begin
end;

end.
