UNIT mTBruch;

interface

uses   mSum;
// Uses-Klausel ggf. anpassen

type
   TBruch = CLASS

     // Attribute
     public
        zNenner : GanzeZahl;
        zZaehler : GanzeZahl;

     //Objektbeziehungen:
        // kenntTBruchrechner () of TBruchrechner;

     // Methoden
     private
        function ggt(pZahl1,pZahl2:GanzeZahl) : GanzeZahl;
     public
        constructor init(pZaehler,pNenner:GanzeZahl);
        procedure erweitereUm(pZahl:GanzeZahl);
        procedure kehrbruch;
        procedure kuerzeUm(pZahl:GanzeZahl);
        procedure kuerzeVoll;
        procedure setzeNenner(pNenner:GanzeZahl);
        procedure setzeZaehler(pZaehler:GanzeZahl);
        function dezimalwert : Zahl;
        function nenner : GanzeZahl;
        function zaehler : GanzeZahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TBruch: Methodendefinition 
//+---------------------------------------------------------------------

//-------- ggt (private) -----------------------------------------------
function TBruch.ggt(pZahl1,pZahl2:GanzeZahl) : GanzeZahl;
Var h : GanzeZahl;
begin
  if pZahl2 > pZahl1 then begin h:=pZahl1; pZahl1:=pZahl2; pZahl2:=h; end;
  while ((pzahl1 mod pzahl2)>0) do
  begin
  h := pzahl1;
  pzahl1 := pzahl2;
  pzahl2 := h mod pzahl2;
  end;
  result := pZahl2;
end;

//-------- init (public) -----------------------------------------------
constructor TBruch.init(pZaehler,pNenner:GanzeZahl);
begin
 zZaehler := pZaehler;
 zNenner  := pNenner;
end;

//-------- erweitereUm (public) ----------------------------------------
procedure TBruch.erweitereUm(pZahl:GanzeZahl);
begin
  zZaehler := zZaehler * pZahl;
  zNenner  := zNenner  * pZahl;
end;

//-------- kehrbruch (public) ------------------------------------------
procedure TBruch.kehrbruch;
Var h:GanzeZahl;
begin
  h        := zZaehler;
  zZaehler := zNenner;
  zNenner  := h;
end;

//-------- kuerzeUm (public) -------------------------------------------
procedure TBruch.kuerzeUm(pZahl:GanzeZahl);
begin
  zNenner := zNenner  div pZahl;
  zZaehler:= zZaehler div pZahl;
end;

//-------- kuerzeVoll (public) -----------------------------------------
procedure TBruch.kuerzeVoll;
begin
  kuerzeUm (ggt(zZaehler,zNenner));
end;

//-------- setzeNenner (public) ----------------------------------------
procedure TBruch.setzeNenner(pNenner:GanzeZahl);
begin
  zNenner := pNenner;
end;

//-------- setzeZaehler (public) ---------------------------------------
procedure TBruch.setzeZaehler(pZaehler:GanzeZahl);
begin
  zZaehler := pZaehler;
end;

//-------- dezimalwert (public) ----------------------------------------
function TBruch.dezimalwert : Zahl;
begin
  result := zZaehler/zNenner;
end;

//-------- nenner (public) ---------------------------------------------
function TBruch.nenner : GanzeZahl;
begin
  result := zNenner;
end;

//-------- zaehler (public) --------------------------------------------
function TBruch.zaehler : GanzeZahl;
begin
  result := zZaehler;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TBruch.gibFrei;
begin
  //nix!
end;

end.
