unit fmBruch;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, mBruch, mKnopf, mTextfeld, mEtikett;

type
  TBruchformular = class(TForm)
    hatTextfeldZaehler: TTextfeld;
    hatTextfeldNenner: TTextfeld;
    hatKnopfErweiternUm: TKnopf;
    hatKnopfKuerzenUm: TKnopf;
    hatKnopfKuerzeVoll: TKnopf;
    hatTextfeldZahl: TTextfeld;
    hatTextfeldDezimalwert: TTextfeld;
    hatKnopfKehrbruch: TKnopf;
    hatEtikettZaehler: TEtikett;
    hatEtikettNenner: TEtikett;
    hatEtikettZahl: TEtikett;
    procedure FormCreate(Sender: TObject);
    procedure hatTextfeldZaehlerTextGeaendert(Sender: TObject);
    procedure hatTextfeldNennerTextGeaendert(Sender: TObject);
    procedure hatKnopfErweiternUmGeklickt(Sender: TObject);
    procedure hatKnopfKuerzenUmGeklickt(Sender: TObject);
    procedure hatKnopfKuerzeVollGeklickt(Sender: TObject);
    procedure hatKnopfKehrbruchGeklickt(Sender: TObject);
    procedure hatTextfeldZahlTextGeaendert(Sender: TObject);
  private
    
  public
    hatBruch:Bruch;
  end;

var
  Bruchformular: TBruchformular;

implementation

{$R *.DFM}

procedure TBruchformular.FormCreate(Sender: TObject);
begin
 hatBruch:=Bruch.init(1,1);
 hatTextfeldZaehler.setzeInhalt(hatBruch.zaehler);
 hatTextfeldNenner.setzeInhalt(hatBruch.nenner);
 hatTextfeldDezimalwert.setzeInhalt(hatBruch.dezimalwert);
end;

procedure TBruchformular.hatTextfeldZaehlerTextGeaendert(Sender: TObject);
begin
  hatBruch.setzeZaehler(hatTextfeldZaehler.inhaltAlsGanzeZahl);
  hatTextfeldDezimalwert.setzeInhalt(hatBruch.dezimalwert);
end;

procedure TBruchformular.hatTextfeldNennerTextGeaendert(Sender: TObject);
begin
 if hatTextfeldNenner.inhaltAlsZahl=0 then hatTextfeldNenner.setzeInhalt(1);

  hatBruch.setzeNenner(hatTextfeldNenner.inhaltAlsGanzeZahl);
  hatTextfeldDezimalwert.setzeInhalt(hatBruch.dezimalwert);
end;

procedure TBruchformular.hatKnopfErweiternUmGeklickt(Sender: TObject);
begin
  hatBruch.erweitereUm(hatTextfeldZahl.inhaltAlsGanzeZahl);
  hatTextfeldZaehler.setzeInhalt(hatBruch.zaehler);
  hatTextfeldNenner.setzeInhalt(hatBruch.nenner);
end;

procedure TBruchformular.hatKnopfKuerzenUmGeklickt(Sender: TObject);
begin
if (hatBruch.zaehler mod hatTextfeldZahl.inhaltAlsGanzeZahl=0)
     and (hatBruch.nenner mod hatTextfeldZahl.inhaltAlsGanzeZahl=0) then
  begin
    hatBruch.kuerzeUm(hatTextfeldZahl.inhaltAlsGanzeZahl);
    hatTextfeldZaehler.setzeInhalt(hatBruch.zaehler);
    hatTextfeldNenner.setzeInhalt(hatBruch.nenner);
  end;
end;

procedure TBruchformular.hatKnopfKuerzeVollGeklickt(Sender: TObject);
begin
  hatBruch.kuerzeVoll;
  hatTextfeldZaehler.setzeInhalt(hatBruch.zaehler);
  hatTextfeldNenner.setzeInhalt(hatBruch.nenner);
end;

procedure TBruchformular.hatKnopfKehrbruchGeklickt(Sender: TObject);
begin
 if not(hatBruch.zaehler=0)then
  begin
    hatBruch.kehrbruch;
    hatTextfeldZaehler.setzeInhalt(hatBruch.zaehler);
    hatTextfeldNenner.setzeInhalt(hatBruch.nenner);
    hatTextfeldDezimalwert.setzeInhalt(hatBruch.dezimalwert);
  end;
end;

procedure TBruchformular.hatTextfeldZahlTextGeaendert(Sender: TObject);
begin
  if hatTextfeldZahl.inhaltAlsGanzeZahl=0 then hatTextfeldZahl.setzeInhalt(1);
end;

end.
