UNIT mTRechteckKnopf;

interface

uses        mSuM, mTKnopf;
// Uses-Klausel ggf. anpassen

type
   TRechteckKnopf = CLASS(TKnopf)

     // Attribute

     // Methoden
     public
        procedure zeichne; override;
        function innerhalb : Wahrheitswert; override;
        destructor gibFrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TRechteckKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (public) --------------------------------------------
procedure TRechteckKnopf.zeichne;
begin
  if zAktiviert
    then
       begin
          hatStift.bewegeBis(zXPos,zYPos);
          hatStift.setzeFarbe(Gelb);
          hatStift.setzeFuellmuster(gefuellt);
          hatStift.zeichneRechteck(zGroesse,28);
          hatStift.setzeFarbe(schwarz);
          hatStift.setzeFuellmuster(durchsichtig);
          hatStift.zeichneRechteck(zGroesse,28);
          hatStift.setzeSchriftGroesse(24);
          hatStift.bewegeBis(zXPos+(zGroesse-hatStift.Textbreite(zAufschrift))/2,zYPos+2);
          hatStift.schreibeText(zAufschrift);
       end
    else
       begin
          hatStift.bewegeBis(zXPos,zYPos);
          hatStift.setzeFarbe(weiss);
          hatStift.setzeFuellmuster(gefuellt);
          hatStift.zeichneRechteck(zGroesse,28);
          hatStift.setzeFarbe(grau);
          hatStift.setzeFuellmuster(durchsichtig);
          hatStift.zeichneRechteck(zGroesse,28);
          hatStift.setzeSchriftGroesse(24);
          hatStift.bewegeBis(zXPos+(zGroesse-hatStift.Textbreite(zAufschrift))/2,zYPos+2);
          hatStift.schreibeText(zAufschrift);
          hatStift.setzeFarbe(schwarz)
       end
end;

//-------- innerhalb (public) ------------------------------------------
function TRechteckKnopf.innerhalb : Wahrheitswert;
begin
  result :=
       (kenntMaus.hPosition > zXpos ) and
       (kenntMaus.hPosition < zXPos + zGroesse) and
       (kenntMaus.vPosition > zYPos) and
       (kenntMaus.vPosition < zYPos+28)
end;

//-------- gibFrei (public) --------------------------------------------
destructor TRechteckKnopf.gibFrei;
begin
   hatStift.bewegeBis(zXPos,zYPos);
   hatStift.setzeFarbe(weiss);
   hatStift.normal;
   hatStift.setzeFuellmuster(gefuellt);
   hatStift.zeichneRechteck(zGroesse,28);
   inherited gibFrei
end;

end.
